--Run SLH_NC_Config_Lua  	
	SLH_NC_Lua = CreateFrame("Frame", "SLH_NC_Lua")
	SLH_NC_Lua:RegisterEvent("ADDON_LOADED")
	SLH_NC_Lua:HookScript("OnEvent", function (self, event, name, ...)
		if (name ~= "SalensLittleHelper") then return end

		--Theoretically speeds up access to global variables by making them local.  This is supposed to be faster.  I have no proof this is true.	
			local _G_SLH = _G 
		
		local SLH_PCSV_UnitName = _G_SLH["SLH_PCSV"]["SLH_PCSV_UnitNameGlobal"]
		local NC_Profile = _G_SLH["SLH_PCSV"][SLH_PCSV_UnitName]["Config"]["NC_Profile"]
			
		--Development Mode Boolean (Controls various Overrides, disable to test and distribute.)
			local SLH_NC_DevMode = false
			
			--[[DevMode]]if SLH_NC_DevMode and name ~= nil then _G_SLH["SLH_SF"]["Config"]["Print"]("NC_Lua addonName: " .. name) end	


		-- Set Variables
			local SLH_NC_SetVars = function (self, event, name, ...)
				-- Test/Create SLH_SV Table			
					if _G_SLH["SLH_SV"] == nil then _G_SLH["SLH_SV"] = {} end			
				-- Test/Create SLH_SV.NC_Profile Table
					if _G_SLH["SLH_SV"][NC_Profile] == nil then _G_SLH["SLH_SV"][NC_Profile] = {}  end	
				-- Test/Create SLH_NC Table
					if _G_SLH["SLH_SV"][NC_Profile]["NC"] == nil then _G_SLH["SLH_SV"][NC_Profile]["NC"] = {}  end	
									
				
				-- Test/Create SLH_NC Variables
					if _G_SLH["SLH_SV"][NC_Profile]["NC"]["Enable"] == nil then _G_SLH["SLH_SV"][NC_Profile]["NC"]["Enable"] = "Y" end
					if _G_SLH["SLH_SV"][NC_Profile]["NC"]["xOfs"] == nil then _G_SLH["SLH_SV"][NC_Profile]["NC"]["xOfs"] = -50 end	
					if _G_SLH["SLH_SV"][NC_Profile]["NC"]["yOfs"] == nil then _G_SLH["SLH_SV"][NC_Profile]["NC"]["yOfs"] = 320 end						
					if _G_SLH["SLH_SV"][NC_Profile]["NC"]["framelevel"] == nil then _G_SLH["SLH_SV"][NC_Profile]["NC"]["framelevel"] = 9000 end	
					if _G_SLH["SLH_SV"][NC_Profile]["NC"]["DisableForCrafting"] == nil then _G_SLH["SLH_SV"][NC_Profile]["NC"]["DisableForCrafting"] = "Y" end
					if _G_SLH["SLH_SV"][NC_Profile]["NC"]["DisableWhenMailBoxIsOpen"] == nil then _G_SLH["SLH_SV"][NC_Profile]["NC"]["DisableWhenMailBoxIsOpen"] = "Y" end
					if _G_SLH["SLH_SV"][NC_Profile]["NC"]["LogOnScan"] == nil then _G_SLH["SLH_SV"][NC_Profile]["NC"]["LogOnScan"] = "N" end
					
				--Reset Pauses on load
					_G_SLH["SLH_SV"][NC_Profile]["NC"]["PostCombatList"] = {}
					_G_SLH["SLH_SV"][NC_Profile]["NC"]["PausedWhileMailing"] = "N"
			
			end


		--SLH_NC Module
			local SLH_NC_Module = function (self, event, SLH_NC_Module_itemLink, SLH_NC_Module_lootstring)	
				
				--[[DevMode]]if SLH_NC_DevMode then _G_SLH["SLH_SF"]["Config"]["Print"]("NC: SLH_NC_Module Start") end		
				local SLH_NC_Bags = {}	
				SLH_NC_Bags[1]=0
				SLH_NC_Bags[2]=1
				SLH_NC_Bags[3]=2
				SLH_NC_Bags[4]=3
				SLH_NC_Bags[5]=4
				for index, SLH_NC_bagID in ipairs(SLH_NC_Bags) do
					local SLH_NC_Bag_numberOfSlots = 0
					SLH_NC_Bag_numberOfSlots = C_Container.GetContainerNumSlots(SLH_NC_bagID)
						
					for SLH_NC_slot = 1, SLH_NC_Bag_numberOfSlots do
						local SLH_NC_icon, 
							SLH_NC_itemCount,
							SLH_NC_locked, 
							SLH_NC_quality, 
							SLH_NC_readable, 
							SLH_NC_lootable, 
							SLH_NC_itemLink, 
							SLH_NC_isFiltered, 
							SLH_NC_noValue, 
							SLH_NC_itemID = ""
				
						SLH_NC_icon, 
							SLH_NC_itemCount,
							SLH_NC_locked, 
							SLH_NC_quality, 
							SLH_NC_readable, 
							SLH_NC_lootable, 
							SLH_NC_itemLink, 
							SLH_NC_isFiltered, 
							SLH_NC_noValue, 
							SLH_NC_itemID = C_Container.GetContainerItemInfo(SLH_NC_bagID, SLH_NC_slot)
							
						if SLH_NC_itemLink ~= nil and not SLH_NC_lootable and SLH_NC_itemLink == SLH_NC_Module_itemLink
						then 
							local SLH_NC_itemName, 
								SLH_NC_itemLink_GetItemInfo, 
								SLH_NC_itemRarity, 
								SLH_NC_itemLevel, 
								SLH_NC_itemMinLevel, 
								SLH_NC_itemType, 
								SLH_NC_itemSubType, 
								SLH_NC_itemStackCount,
								SLH_NC_itemEquipLoc, 
								SLH_NC_itemIcon, 
								SLH_NC_itemSellPrice, 
								SLH_NC_itemClassID, -- 9 = Recipes, Cannot call UseContainerItem for recipes.
								SLH_NC_itemSubClassID, 
								SLH_NC_bindType, 
								SLH_NC_expacID, 
								SLH_NC_itemSetID, 
								SLH_NC_isCraftingReagent = GetItemInfo(SLH_NC_itemLink) 
					
							local SLH_NC_GetDetailedItemLevelInfo_effectiveILvl, 
								SLH_NC_isPreview, 
								SLH_NC_baseILvl = GetDetailedItemLevelInfo(SLH_NC_Module_itemLink)
															
							--[[
									0: Consumable

									subclassID	itemSubType					Description
									0			Explosives and Devices	
									1			Potion	
									2			Elixir	
									3			Flask	
									4			Scroll (OBSOLETE)	
									5			Food & Drink	
									6			Item Enhancement (OBSOLETE)	
									7			Bandage	
									8			Other	
									9			Vantus Runes	
									
									8: Item Enhancement
								]]
							
							--[[DevMode]]if SLH_NC_DevMode and SLH_NC_Module_itemLink ~= nil then _G_SLH["SLH_SF"]["Config"]["Print"]("NC SLH_NC_Module_itemLink: " .. SLH_NC_Module_itemLink) end	
							--[[DevMode]]if SLH_NC_DevMode and SLH_NC_itemLink ~= nil then _G_SLH["SLH_SF"]["Config"]["Print"]("NC SLH_NC_itemLink: " .. SLH_NC_itemLink) end
							--[[DevMode]]if SLH_NC_DevMode and SLH_NC_itemClassID ~= nil then _G_SLH["SLH_SF"]["Config"]["Print"]("NC SLH_NC_itemClassID: " .. SLH_NC_itemClassID) end
							--[[DevMode]]if SLH_NC_DevMode and SLH_NC_itemSubClassID ~= nil then _G_SLH["SLH_SF"]["Config"]["Print"]("NC SLH_NC_itemSubClassID: " .. SLH_NC_itemSubClassID) end
														
							if SLH_NC_itemLink ~= nil and SLH_NC_itemSubType ~= "Junk"
								and(
									(SLH_NC_itemClassID == 0
										and (SLH_NC_itemSubClassID ~= 8	--8 is unlisted, but bring up grey items in Legion?
											or (SLH_NC_itemSubClassID == 8	
												and(string.find(SLH_NC_itemLink, "Heirloom") ~= nil 
													or string.find(SLH_NC_itemLink, "Celebration Package") ~= nil 
													or string.find(SLH_NC_itemLink, "Celebration Firework") ~= nil 
													or string.find(SLH_NC_itemLink, "Commendation") ~= nil 
													or string.find(SLH_NC_itemLink, "Broker Mark of Distinction") ~= nil 
													or string.find(SLH_NC_itemLink, "Incense of Infinity") ~= nil 
													or string.find(SLH_NC_itemLink, "Timebound Ruminations") ~= nil 
													or string.find(SLH_NC_itemLink, "Piece of Goop") ~= nil 
													or string.find(SLH_NC_itemLink, "Enlightened Offering") ~= nil 
													or string.find(SLH_NC_itemLink, "Decanter of Untapped Potential") ~= nil 
													or string.find(SLH_NC_itemLink, "Vessel of Profound Possibilities") ~= nil 
													)
												)
											)
										)
									or (SLH_NC_itemClassID == 2
										and (
											(SLH_NC_itemSubClassID == 8	
												and(string.find(SLH_NC_itemLink, "Percussive Maintenance Instrument") ~= nil -- Zereth Mortis Cosmetic
													or string.find(SLH_NC_itemLink, "Protomineral Extractor") ~= nil -- Zereth Mortis Cosmetic
													or string.find(SLH_NC_itemLink, "Protoflora Harvester") ~= nil -- Zereth Mortis Cosmetic
													--or string.find(SLH_NC_itemLink, "Greatsword") ~= nil -- Zereth Mortis Cosmetic
													or string.find(SLH_NC_itemLink, "Tormented Mawsteel Greatsword") ~= nil -- Zereth Mortis Cosmetic
													)
												)
											)
										)
									or (SLH_NC_itemClassID == 3
										and (SLH_NC_itemSubClassID == 9
											--and string.find(SLH_NC_itemLink, "Recipe:") ~= nil											
											)										
										)
									or (SLH_NC_itemClassID == 7
										and (SLH_NC_itemSubClassID == 11
											and string.find(SLH_NC_itemLink, "Recipe:") ~= nil											
											)										
										)
									or SLH_NC_itemClassID == 8
									or SLH_NC_itemClassID == 9
									or (SLH_NC_itemClassID == 15
										and (
											GetZoneText() == "The Waking Shores" or 
											GetZoneText() == "Ohn'ahran Plains" or 
											GetZoneText() == "Thaldraszus" or 
											GetZoneText() == "The Azure Span" or 
											GetZoneText() == "Valdrakken"
										)						
										and (SLH_NC_itemSubClassID == 0									
											or SLH_NC_itemSubClassID == 2 
											or SLH_NC_itemSubClassID == 4
											or SLH_NC_itemSubClassID == 5 
											or SLH_NC_itemSubClassID == 6
											)
										)	
									or (SLH_NC_itemClassID == 15
										and (SLH_NC_itemSubClassID == 0
												and (string.find(SLH_NC_itemLink, "Amethyl Crystal") ~= nil
													or string.find(SLH_NC_itemLink, "Iron Horde Weapon Cache") ~= nil 
													or string.find(SLH_NC_itemLink, "Exploratron 2000 Spare Parts") ~= nil 
													or string.find(SLH_NC_itemLink, "Exploratron 2000 Spare Parts") ~= nil 
													or string.find(SLH_NC_itemLink, "Scouting Map") ~= nil 
													or string.find(SLH_NC_itemLink, "Bushel of Mysterious Fruit") ~= nil -- Zereth Mortis Toy
													or string.find(SLH_NC_itemLink, "Infested Automa Core") ~= nil -- Zereth Mortis Toy
													or string.find(SLH_NC_itemLink, "Mortis Mover") ~= nil -- Zereth Mortis Toy
													or string.find(SLH_NC_itemLink, "Protopological Cube") ~= nil -- Zereth Mortis Toy
													or string.find(SLH_NC_itemLink, "Xy'rath's Booby-Trapped Cache") ~= nil -- Zereth Mortis Toy
													or string.find(SLH_NC_itemLink, "Infested Automa Core") ~= nil -- Zereth Mortis Toy
													)									
											or SLH_NC_itemSubClassID == 2 
											or (SLH_NC_itemSubClassID == 4 
												and (string.find(SLH_NC_itemLink, "Fractal Thoughtbinder") ~= nil
													or string.find(SLH_NC_itemLink, "Grimoire of Knowledge") ~= nil
													or string.find(SLH_NC_itemLink, "Wisps of Memory") ~= nil
													or string.find(SLH_NC_itemLink, "Expanding Prism") ~= nil -- really Mind-Expanding Prism, somehitng not right with the Dash
													or string.find(SLH_NC_itemLink, "Crystalline Memory Repository") ~= nil
													or string.find(SLH_NC_itemLink, "Research Report: All-Seeing Crystal") ~= nil
													or string.find(SLH_NC_itemLink, "The Archivists' Codex") ~= nil
													or string.find(SLH_NC_itemLink, "Barracks, Level 1") ~= nil
													or string.find(SLH_NC_itemLink, "Stonewrought Sentry") ~= nil
													or string.find(SLH_NC_itemLink, "Muckpool Cookpot") ~= nil
													or string.find(SLH_NC_itemLink, "Fae Harp") ~= nil
													or string.find(SLH_NC_itemLink, "Hearty Dragon Plume") ~= nil
													or string.find(SLH_NC_itemLink, "Fae Pipes") ~= nil
													or string.find(SLH_NC_itemLink, "Stylish Black Parasol") ~= nil
													or string.find(SLH_NC_itemLink, "Phial of Ravenous Slime") ~= nil
													or string.find(SLH_NC_itemLink, "The Necronom") ~= nil-- really The Necronom-i-nom, somehitng not right with the Dash
													or string.find(SLH_NC_itemLink, "Scroll or Aeons") ~= nil
													or string.find(SLH_NC_itemLink, "Kyrian Bell") ~= nil
													or string.find(SLH_NC_itemLink, "Bondable Val'kyr Diadem") ~= nil
													or string.find(SLH_NC_itemLink, "Puntable Marmot") ~= nil
													or string.find(SLH_NC_itemLink, "Admiral Pocopoc") ~= nil -- Zereth Mortis Pocopc Appearance
													or string.find(SLH_NC_itemLink, "Adventurous Pocopoc") ~= nil -- Zereth Mortis Pocopc Appearance
													or string.find(SLH_NC_itemLink, "Chef Pocopoc") ~= nil -- Zereth Mortis Pocopc Appearance
													or string.find(SLH_NC_itemLink, "Dapper Pocopoc") ~= nil -- Zereth Mortis Pocopc Appearance
													or string.find(SLH_NC_itemLink, "Peaceful Pocopoc") ~= nil -- Zereth Mortis Pocopc Appearance
													or string.find(SLH_NC_itemLink, "Pepepec") ~= nil -- Zereth Mortis Pocopc Appearance
													or string.find(SLH_NC_itemLink, "Pirate Pocopoc") ~= nil -- Zereth Mortis Pocopc Appearance
													or string.find(SLH_NC_itemLink, "Pocobold") ~= nil -- Zereth Mortis Pocopc Appearance
													or string.find(SLH_NC_itemLink, "Wicked Pocopoc") ~= nil -- Zereth Mortis Pocopc Appearance
													or string.find(SLH_NC_itemLink, "Bushel of Mysterious Fruit") ~= nil -- Zereth Mortis Toy
													or string.find(SLH_NC_itemLink, "Infested Automa Core") ~= nil -- Zereth Mortis Toy
													or string.find(SLH_NC_itemLink, "Mortis Mover") ~= nil -- Zereth Mortis Toy
													or string.find(SLH_NC_itemLink, "Protopological Cube") ~= nil -- Zereth Mortis Toy
													or string.find(SLH_NC_itemLink, "Xy'rath's Booby-Trapped Cache") ~= nil -- Zereth Mortis Toy
													or string.find(SLH_NC_itemLink, "Infested Automa Core") ~= nil -- Zereth Mortis Toy
													or string.find(SLH_NC_itemLink, "Makaris's Satchel of Mines") ~= nil -- Zereth Mortis Toy
													or string.find(SLH_NC_itemLink, "Traveler's Anima Cache") ~= nil 
													or string.find(SLH_NC_itemLink, "A Tiny Sinstone") ~= nil 
													or string.find(SLH_NC_itemLink, "A Tiny Winter Staff") ~= nil 
													)
												)	
											or SLH_NC_itemSubClassID == 5 
											or SLH_NC_itemSubClassID == 6
											)
										)	
									or SLH_NC_itemClassID == 16
									or SLH_NC_itemClassID == 17
									or SLH_NC_itemClassID == 18
								)
							then
								--[[DevMode]]if SLH_NC_DevMode and SLH_NC_lootable and SLH_NC_itemLink ~= nil then _G_SLH["SLH_SF"]["Config"]["Print"]("NC: " .. SLH_NC_itemLink.. " is Consumable") end	
								--[[DevMode]]if SLH_NC_DevMode and SLH_NC_itemType ~= nil then _G_SLH["SLH_SF"]["Config"]["Print"]("NC SLH_NC_itemType: " .. SLH_NC_itemType) end
								--[[DevMode]]if SLH_NC_DevMode and SLH_NC_itemSubType ~= nil then _G_SLH["SLH_SF"]["Config"]["Print"]("NC SLH_NC_itemSubType: " .. SLH_NC_itemSubType) end
								
								local SLH_NC_isLocked = C_Item.IsLocked(ItemLocation:CreateFromBagAndSlot(SLH_NC_bagID, SLH_NC_slot) )
								if SLH_NC_isLocked 
								then 
									--[[DevMode]]if SLH_NC_DevMode then _G_SLH["SLH_SF"]["Config"]["Print"]("NC SLH_NC_isLocked: true") end
								else 
									--[[DevMode]]if SLH_NC_DevMode then _G_SLH["SLH_SF"]["Config"]["Print"]("NC SLH_NC_isLocked: false") end
								end
								
								if UnitAffectingCombat("player")
								then	
									--[[DevMode]]if SLH_NC_DevMode then _G_SLH["SLH_SF"]["Config"]["Print"]("NC: Unit is in Combat, added to PostCombatList.") end
									local SLH_NC_newEntry = #_G_SLH["SLH_SV"][NC_Profile]["NC"]["PostCombatList"]+1
									_G_SLH["SLH_SV"][NC_Profile]["NC"]["PostCombatList"][SLH_NC_newEntry] = {}
									_G_SLH["SLH_SV"][NC_Profile]["NC"]["PostCombatList"][SLH_NC_newEntry][1] = SLH_NC_Module_itemLink
									_G_SLH["SLH_SV"][NC_Profile]["NC"]["PostCombatList"][SLH_NC_newEntry][2] = SLH_NC_Module_lootstring
									return 
								end
								
								if _G_SLH["SLH_SV"][NC_Profile]["NC"]["framelevel"] > 10000
								then	
									_G_SLH["SLH_SV"][NC_Profile]["NC"]["framelevel"] = 9000
								else 
									_G_SLH["SLH_SV"][NC_Profile]["NC"]["framelevel"] = _G_SLH["SLH_SV"][NC_Profile]["NC"]["framelevel"] + 1									
								end
														
								local SLH_NC_SecureActionButton = CreateFrame("CheckButton", nil, UIParent, "SecureActionButtonTemplate,ActionButtonTemplate")
								SLH_NC_SecureActionButton:SetPoint("CENTER", UIParent, _G_SLH["SLH_SV"][NC_Profile]["NC"]["xOfs"], _G_SLH["SLH_SV"][NC_Profile]["NC"]["yOfs"])	
								SLH_NC_SecureActionButton:SetAttribute("type1", "item")
								SLH_NC_SecureActionButton:SetAttribute("item", SLH_NC_itemName)
								SLH_NC_SecureActionButton:RegisterForClicks("AnyUp")
								SLH_NC_SecureActionButton:RegisterForClicks("anyDown")
								SLH_NC_SecureActionButton:SetSize(40, 40)
								SLH_NC_SecureActionButton:SetFrameLevel(_G_SLH["SLH_SV"][NC_Profile]["NC"]["framelevel"])

								local SLH_NC_icon = SLH_NC_SecureActionButton:CreateTexture(nil, "ARTWORK")
								SLH_NC_icon:SetAllPoints(true)
								SLH_NC_icon:SetTexture(GetItemIcon(SLH_NC_itemID))
								SLH_NC_SecureActionButton.icon = SLH_NC_icon	
								
								SLH_NC_SecureActionButton:Show()
									
								--Make Dragable
								SLH_NC_SecureActionButton:SetMovable(true)
								SLH_NC_SecureActionButton:EnableMouse(true)					
								SLH_NC_SecureActionButton:RegisterForDrag("LeftButton")
								SLH_NC_SecureActionButton:SetScript("OnDragStart", function(SLH_NC_SecureActionButton) if IsShiftKeyDown() then SLH_NC_SecureActionButton:StartMoving() end end)
								SLH_NC_SecureActionButton:SetScript("OnDragStop", SLH_NC_SecureActionButton.StopMovingOrSizing)
																
								SLH_NC_SecureActionButton:HookScript("OnClick", function (self, button, down) 
									if SLH_NC_DevMode and SLH_NC_Module_itemLink ~= nil then _G_SLH["SLH_SF"]["Config"]["Print"]("NC: SLH_NC_Module_itemLink" .. SLH_NC_Module_itemLink) end
									C_Timer.After(.2, function() 
										if SLH_NC_DevMode then _G_SLH["SLH_SF"]["Config"]["Print"]("NC: Get Here 1") end
										if SLH_NC_DevMode and SLH_NC_Module_itemLink ~= nil then _G_SLH["SLH_SF"]["Config"]["Print"]("NC button: " .. button) end
										if button == "RightButton" or GetItemCount(SLH_NC_Module_itemLink) == 0
										then
											if SLH_NC_DevMode then _G_SLH["SLH_SF"]["Config"]["Print"]("NC: Get Here 2") end
											self:Hide() 
											RegisterAttributeDriver(self,"visibility","[combat]hide;hide")
											if SLH_NC_DevMode then _G_SLH["SLH_SF"]["Config"]["Print"]("NC: Get Here 2a") end
											return	
										else
											if SLH_NC_DevMode then _G_SLH["SLH_SF"]["Config"]["Print"]("NC: Get Here 3") end
											C_Timer.After(1, function() 
												if GetItemCount(SLH_NC_Module_itemLink) == 0
												then
													if SLH_NC_DevMode then _G_SLH["SLH_SF"]["Config"]["Print"]("NC: Get Here 4") end
													self:Hide() 
													RegisterAttributeDriver(self,"visibility","[combat]hide;hide")
													if SLH_NC_DevMode then _G_SLH["SLH_SF"]["Config"]["Print"]("NC: Get Here 4a") end
													return	
												else
													if SLH_NC_DevMode then _G_SLH["SLH_SF"]["Config"]["Print"]("NC: Get Here 5") end
													C_Timer.After(1, function() 
														if GetItemCount(SLH_NC_Module_itemLink) == 0
														then
															if SLH_NC_DevMode then _G_SLH["SLH_SF"]["Config"]["Print"]("NC: Get Here 6") end
															self:Hide() 
															RegisterAttributeDriver(self,"visibility","[combat]hide;hide")
															if SLH_NC_DevMode then _G_SLH["SLH_SF"]["Config"]["Print"]("NC: Get Here 6a") end
															return	
														else
															if SLH_NC_DevMode then _G_SLH["SLH_SF"]["Config"]["Print"]("NC: Get Here 7") end
															C_Timer.After(1, function() 
																if GetItemCount(SLH_NC_Module_itemLink) == 0
																then
																	if SLH_NC_DevMode then _G_SLH["SLH_SF"]["Config"]["Print"]("NC: Get Here 8") end
																	self:Hide() 
																	RegisterAttributeDriver(self,"visibility","[combat]hide;hide")
																	if SLH_NC_DevMode then _G_SLH["SLH_SF"]["Config"]["Print"]("NC: Get Here 8a") end
																	return													
																end									
															end)
														end									
													end)
												end									
											end)
										end									
									end)
								end)
								
								SLH_NC_SecureActionButton:HookScript("OnEnter", function(widget)
									GameTooltip:SetOwner(SLH_NC_SecureActionButton, "ANCHOR_RIGHT")
									GameTooltip:SetHyperlink(SLH_NC_Module_itemLink)
									GameTooltip:AddLine("\n\nSLH_NC_:\n  Left Click: Use ".. SLH_NC_Module_itemLink .. "\n  Right Click: Hide Button\n  Hold Shift+Left Mouse Button and Drag to move to your preferred location.", _G_SLH["SLH_SF"]["SLH_TooltipColors"].r, _G_SLH["SLH_SF"]["SLH_TooltipColors"].g, _G_SLH["SLH_SF"]["SLH_TooltipColors"].b, true)
									GameTooltip:Show()
								end)
								SLH_NC_SecureActionButton:HookScript("OnLeave", function(widget) 
									GameTooltip:Hide()
									local SLH_NC_point, SLH_NC_relativeTo, SLH_NC_relativePoint,SLH_NC_xOfs, SLH_NC_yOfs = SLH_NC_SecureActionButton:GetPoint(n)
									
									_G_SLH["SLH_SV"][NC_Profile]["NC"]["xOfs"] = SLH_NC_xOfs
									_G_SLH["SLH_SV"][NC_Profile]["NC"]["yOfs"] = SLH_NC_yOfs
								end)
								
								RegisterAttributeDriver(SLH_NC_SecureActionButton,"visibility","[combat]hide;show")
								
								return
							end
						end
					end
				end
				return
			end

		--SLH_NC_Delay
			local SLH_NC_Delay = function (self, event, ...)		
				--[[DevMode]]if SLH_NC_DevMode and event ~= nil then _G_SLH["SLH_SF"]["Config"]["Print"]("NC: " .. event) end
				if event == "MAIL_SHOW" 
				then  
					_G_SLH["SLH_SV"][NC_Profile]["NC"]["PausedWhileMailing"] = "Y"
					return 
				elseif event == "MAIL_CLOSED" 
				then  
					_G_SLH["SLH_SV"][NC_Profile]["NC"]["PausedWhileMailing"] = "N"
					return 
				end	
				--[[DevMode]]if SLH_NC_DevMode and _G_SLH["SLH_SV"][NC_Profile]["NC"]["DisableWhenMailBoxIsOpen"] == "Y" and _G_SLH["SLH_SV"][NC_Profile]["NC"]["PausedWhileMailing"] == "Y" then _G_SLH["SLH_SF"]["Config"]["Print"]("NC: Paused While Mailing") end
				if _G_SLH["SLH_SV"][NC_Profile]["NC"]["DisableWhenMailBoxIsOpen"] == "Y" and _G_SLH["SLH_SV"][NC_Profile]["NC"]["PausedWhileMailing"] == "Y" then return end						
				if IsAltKeyDown() or event == "ADDON_LOADED" then return end	

				local SLH_NC_lootstring, 
					SLH_NC_playerName , 
					SLH_NC_languageName , 
					SLH_NC_channelName , 
					SLH_NC_playerName2 , 
					SLH_NC_specialFlags , 
					SLH_NC_zoneChannelID , 
					SLH_NC_channelIndex , 
					SLH_NC_channelBaseName , 
					unused , 
					SLH_NC_lineID , 
					SLH_NC_SenderGUID, 
					SLH_NC_bnSenderID , 
					SLH_NC_isMobile  , 
					SLH_NC_isSubtitle  , 
					SLH_NC_hideSenderInLetterbox  , 
					SLH_NC_supressRaidIcons  = ...
				local SLH_NC_itemLink = string.match(SLH_NC_lootstring,"|%x+|Hitem:.-|h.-|h|r")
				local SLH_NC_UnitName = string.gsub(UnitName("player"), " ", "")
				local SLH_NC_realmName = string.gsub(GetRealmName(), " ", "")
				local SLH_NC_UnitName_realmName = SLH_NC_UnitName .. "-" .. SLH_NC_realmName
				SLH_NC_playerName = string.gsub(SLH_NC_playerName, " ", "")
				
				if SLH_NC_UnitName_realmName ~= SLH_NC_playerName then return end
				--[[DevMode]]if SLH_NC_DevMode then _G_SLH["SLH_SF"]["Config"]["Print"]("NC: Player and Realm Name Match") end			
				
				if _G_SLH["SLH_SV"][NC_Profile]["NC"]["DisableForCrafting"] == "Y" and string.find(SLH_NC_lootstring, "You create") then return end
				--[[DevMode]]if SLH_NC_DevMode then _G_SLH["SLH_SF"]["Config"]["Print"]("NC: Not a Crafted Item") end		
				
				C_Timer.After(1, function() SLH_NC_Module(self, event, SLH_NC_itemLink, SLH_NC_lootstring) end) 
				return
			end
			
		--SLH_NC_Delay2
			_G_SLH["SLH_SF"]["SLH_NC_Delay2"] = function (self, event, SLH_NC_itemLink, SLH_NC_lootstring)	
				--[[DevMode]]if SLH_NC_DevMode and SLH_NC_itemLink ~= nil then _G_SLH["SLH_SF"]["Config"]["Print"]("NC: Delay2 SLH_NC_itemLink = " .. SLH_NC_itemLink) end		
				--[[DevMode]]if SLH_NC_DevMode and SLH_NC_lootstring ~= nil then _G_SLH["SLH_SF"]["Config"]["Print"]("NC: Delay2 SLH_NC_lootstring = " .. SLH_NC_lootstring) end	
				C_Timer.After(1, function() SLH_NC_Module(self, event, SLH_NC_itemLink, SLH_NC_lootstring) end)	
			end

		--SLH_NC_PostCombat
			_G_SLH["SLH_SF"]["SLH_NC_PostCombat"] = function (self, event, SLH_NC_itemLink, SLH_NC_lootstring)				
				if next(_G_SLH["SLH_SV"][NC_Profile]["NC"]["PostCombatList"]) ~= nil
				then
					for i=#_G_SLH["SLH_SV"][NC_Profile]["NC"]["PostCombatList"],1,-1 do	
						C_Timer.After(1, function() 
							if _G_SLH["SLH_SV"][NC_Profile]["NC"]["PostCombatList"][i] ~= nil
							then				
								local SLH_NC_itemLink = _G_SLH["SLH_SV"][NC_Profile]["NC"]["PostCombatList"][i][1]
								local SLH_NC_lootstring = _G_SLH["SLH_SV"][NC_Profile]["NC"]["PostCombatList"][i][2]
								--[[DevMode]]if SLH_NC_DevMode and i ~= nil then _G_SLH["SLH_SF"]["Config"]["Print"]("NC: PostCombat index = " .. i) end	
								--[[DevMode]]if SLH_NC_DevMode and SLH_NC_itemLink ~= nil then _G_SLH["SLH_SF"]["Config"]["Print"]("NC: PostCombat SLH_NC_itemLink = " .. SLH_NC_itemLink) end	
								--[[DevMode]]if SLH_NC_DevMode and SLH_NC_lootstring ~= nil then _G_SLH["SLH_SF"]["Config"]["Print"]("NC: PostCombat SLH_NC_lootstring = " .. SLH_NC_lootstring) end									
								if _G_SLH["SLH_SV"][NC_Profile]["NC"]["PostCombatList"][i][1] ~= nil and _G_SLH["SLH_SV"][NC_Profile]["NC"]["PostCombatList"][i][2]
								then	
									_G_SLH["SLH_SF"]["SLH_NC_Delay2"](self, event, SLH_NC_itemLink, SLH_NC_lootstring) 	
								end								
							end 
							_G_SLH["SLH_SV"][NC_Profile]["NC"]["PostCombatList"][i][1] = nil;
							_G_SLH["SLH_SV"][NC_Profile]["NC"]["PostCombatList"][i][2] = nil;
							_G_SLH["SLH_SV"][NC_Profile]["NC"]["PostCombatList"][i]	 = nil;
							return
						end)
					end	
					return	
				end 	
			end

		--SLH_NC Module Scan
			_G_SLH["SLH_SF"]["SLH_NC_Scan"]  = function (self, event, ...)	
		
				--[[DevMode]]if SLH_NC_DevMode then _G_SLH["SLH_SF"]["Config"]["Print"]("NC: SLH_NC_Module_Scan Start") end		
				local SLH_NC_Bags = {}	
				SLH_NC_Bags[1]=0
				SLH_NC_Bags[2]=1
				SLH_NC_Bags[3]=2
				SLH_NC_Bags[4]=3
				SLH_NC_Bags[5]=4
				for index, SLH_NC_bagID in ipairs(SLH_NC_Bags) do
					local SLH_NC_Bag_numberOfSlots = 0
					SLH_NC_Bag_numberOfSlots = C_Container.GetContainerNumSlots(SLH_NC_bagID)
					for SLH_NC_slot = 1, SLH_NC_Bag_numberOfSlots do
						local SLH_NC_icon, 
							SLH_NC_itemCount,
							SLH_NC_locked, 
							SLH_NC_quality, 
							SLH_NC_readable, 
							SLH_NC_lootable, 
							SLH_NC_itemLink, 
							SLH_NC_isFiltered, 
							SLH_NC_noValue, 
							SLH_NC_itemID = ""
				
						SLH_NC_icon, 
							SLH_NC_itemCount,
							SLH_NC_locked, 
							SLH_NC_quality, 
							SLH_NC_readable, 
							SLH_NC_lootable, 
							SLH_NC_itemLink, 
							SLH_NC_isFiltered, 
							SLH_NC_noValue, 
							SLH_NC_itemID = C_Container.GetContainerItemInfo(SLH_NC_bagID, SLH_NC_slot)
							
						if SLH_NC_itemLink ~= nil
						then 
							local SLH_NC_lootstring = string.match(SLH_NC_itemLink, "item[%-?%d:]+")
							SLH_NC_Module(self, event, SLH_NC_itemLink, SLH_NC_lootstring)
						end
					end
				end
				return
			end
			
		--SLH_NC EventCall
			local SLH_NC_Events = function (SLH_NC_Options, event, name, ...)
				--[[DevMode]]if SLH_NC_DevMode and event ~= nil then _G_SLH["SLH_SF"]["Config"]["Print"]("NC: " .. event) end
				--if _G_SLH["SLH_SV"][NC_Profile]["NC"]["DisableAtMaxLevel"] == "Y" and UnitLevel("player") == 60 then return end
				_G_SLH["SLH_SV"][NC_Profile]["NC"]["PausedWhileMailing"] = "N"
					
				
				Run_SLH_NC = CreateFrame("Frame","Run_SLH_NC_")
				Run_SLH_NC:RegisterEvent("CHAT_MSG_LOOT")		
				Run_SLH_NC:RegisterEvent("MAIL_SHOW")		
				Run_SLH_NC:RegisterEvent("MAIL_CLOSED")		
				if _G_SLH["SLH_SV"][NC_Profile]["NC"]["Enable"] == "Y"
				then 
					Run_SLH_NC:HookScript("OnEvent", function (self, event, ...)		
						SLH_NC_Delay(self, event, ...)	
					end)
				end
				
				Run_SLH_NC_PostCombat= CreateFrame("Frame","Run_SLH_NC_PostCombat")
				Run_SLH_NC_PostCombat:RegisterEvent("PLAYER_REGEN_ENABLED")		
				if _G_SLH["SLH_SV"][NC_Profile]["NC"]["Enable"] == "Y"
				then 
					Run_SLH_NC_PostCombat:HookScript("OnEvent", function (self, event, ...)		
						_G_SLH["SLH_SF"]["SLH_NC_PostCombat"](self, event, ...)	
					end)
				end
									
				if _G_SLH["SLH_SV"][NC_Profile]["NC"]["LogOnScan"] == "Y"
				then
					Run_SLH_NC_Scan = CreateFrame("Frame","Run_SLH_NC_Scan")
					Run_SLH_NC_Scan:RegisterEvent("PLAYER_ENTERING_WORLD")		
					if _G_SLH["SLH_SV"][NC_Profile]["NC"]["Enable"] == "Y"
					then 
						Run_SLH_NC_Scan:HookScript("OnEvent", function (self, event, ...)		
							_G_SLH["SLH_SF"]["SLH_NC_Scan"](self, event, ...)	
						end)
					end
				end
			end

		--SLH_NC Config Screen
			local SLH_NC_Frames = function  (self, event, name, ...)

				-- SLH_NC Options
					local SLH_NC_Options = CreateFrame( "Frame", "SLH_NC_Options")
					SLH_NC_Options.name = "New Consumables"
					-- Specify childness of this panel (this puts it under the little red [+], instead of giving it a normal AddOn category)
						SLH_NC_Options.parent = SLH_Config_Panel.name
					-- Add the child to the Interface Options
						InterfaceOptions_AddCategory(SLH_NC_Options)
					--Add Title
						local SLH_NC_OptionsTitle = SLH_NC_Options:CreateFontString(nil, "ARTWORK","GameFontNormalLarge")
						SLH_NC_OptionsTitle:SetPoint("TOPLEFT", 10, -10)
						SLH_NC_OptionsTitle:SetText("Salen's Little Helper - New Consumables Options")

			
				--SLH_NC_Detail - Create Scroll Frame		
					SLH_NC_Detail = securecall(_G_SLH["SLH_SF"]["SLH_CreateScrollFrame"],SLH_NC_Options, --self
						"SLH_NC_Detail", --FrameName
						SLH_NC_Options, --TOPLEFTrelativeFrame
						5, --TOPLEFTxOffset
						-30, --TOPLEFTyOffset
						SLH_NC_Options, --BOTTOMRIGHTrelativeFrame
						-5, --BOTTOMRIGHTxOffset
						5,--BOTTOMRIGHTyOffset
						"New Consumables Options" -- Title
						)
					SLH_NC_Detail.ScrollBar:ClearAllPoints()
					SLH_NC_Detail.ScrollBar:SetPoint("TOPLEFT", SLH_NC_Detail, "TOPRIGHT", -25, -20)
					SLH_NC_Detail.ScrollBar:SetPoint("BOTTOMRIGHT", SLH_NC_Detail, "BOTTOMRIGHT", -5, 25)
					SLH_NC_Detail:SetClipsChildren(true)		
					
					--(Uncomment to) Set Background Color
						--SLH_NC_Detail.bg = SLH_NC_Detail:CreateTexture(nil, "BACKGROUND")
						--SLH_NC_Detail.bg:SetAllPoints(true)
						--SLH_NC_Detail.bg:SetColorTexture(0.8, 0.4, 0, 0.2)
					--End Set Background Color

					--SLH_NC_DetailScrollFrameChild
						local SLH_NC_DetailScrollFrameChild = CreateFrame("Frame", nil, SLH_NC_Detail)
						SLH_NC_DetailScrollFrameChild:SetSize(600, 470)
							--(Uncomment to) Set Background Color
								--SLH_NC_DetailScrollFrameChild.bg = SLH_NC_DetailScrollFrameChild:CreateTexture(nil, "BACKGROUND")
								--SLH_NC_DetailScrollFrameChild.bg:SetAllPoints(true)
								--SLH_NC_DetailScrollFrameChild.bg:SetColorTexture(0.2, 0.6, 0, 0.8)
							--End Set Background Color
						SLH_NC_Detail:SetScrollChild(SLH_NC_DetailScrollFrameChild)	
						SLH_NC_DetailScrollFrameChild:SetClipsChildren(true)		
			
					

					--SLH_NC_Detail Title 
						SLH_NC_DetailScrollFrameChild.title = SLH_NC_DetailScrollFrameChild:CreateFontString (nil, "OVERLAY")
						SLH_NC_DetailScrollFrameChild.title:SetFontObject("GameFontHighlight")
						SLH_NC_DetailScrollFrameChild.title:SetPoint("LEFT", SLH_NC_DetailScrollFrameChild.TitleBg, "LEFT", 5, 0)
						SLH_NC_DetailScrollFrameChild.title:SetText("New Consumables Options")	
						SLH_NC_DetailScrollFrameChild.title:SetTextColor(_G_SLH["SLH_SF"]["SLH_TitleColors"].r, _G_SLH["SLH_SF"]["SLH_TitleColors"].g, _G_SLH["SLH_SF"]["SLH_TitleColors"].b, _G_SLH["SLH_SF"]["SLH_TitleColors"].a)					

					--MasterFrame.SLH_NC_Detail Buttons
						-- Enable_SLH_NC Check Button:
							Enable_SLH_NC = securecall(_G_SLH["SLH_SF"]["SLH_CreateCheckButton"],SLH_NC_Options, --self
								"TOPLEFT", --point
								SLH_NC_DetailScrollFrameChild, --relativeFrame
								"Enable_SLH_NC_", --FrameName
								"TOPLEFT", --relativePoint
								20, --Width
								20, --Height
								10, --xOffset
								-20, --yOffset
								"SLH_SV", --SVPath0
								NC_Profile, --SVPath1
								"NC", --SVPath2
								"Enable", --SVPath3
								"Enable New Consumables", --text
								"Creates a PopUp Icon for using the new Consumable\n\nLeft Click to Use it, Right Click to Close the icon.\n\nIcon will Automatically Hide During Combat." --tooltip
								)
								Enable_SLH_NC_:HookScript("OnClick", function(self, arg1)			
									if Enable_SLH_NC_:GetChecked() 
										then 
											_G_SLH["SLH_SV"][NC_Profile]["NC"]["Enable"] = "Y"
											SLH_NC_SetVars(self, event, name)
											SLH_NC_Events(self, event, name)
										else 
											_G_SLH["SLH_SV"][NC_Profile]["NC"]["Enable"] = "N"
											--if _G_SLH["SLH_SV"][NC_Profile]["NC"]["DisableAtMaxLevel"] == "Y" and UnitLevel("player") == 60 then return end
											
											if Run_SLH_NC_ActiveQuests then Run_SLH_NC_ActiveQuests:UnregisterAllEvents()	end
											if Run_SLH_NC_CompleteQuests then Run_SLH_NC_CompleteQuests:UnregisterAllEvents()	end
											if Run_SLH_NC_AvailableQuests then Run_SLH_NC_AvailableQuests:UnregisterAllEvents()	end
											if Run_SLH_NC_AcceptQuests then Run_SLH_NC_AcceptQuests:UnregisterAllEvents()	end				
									end
								end)
										
						-- SLH_NC_SLH_NC_xOfs - in seconds
							SLH_NC_SLH_NC_xOfs = securecall(_G_SLH["SLH_SF"]["SLH_CreateSlider"],SLH_NC_Options, --
								"TOPLEFT", --point
								Enable_SLH_NC_, --relativeFrame
								"SLH_NC_SLH_NC_xOfs" , --FrameName
								"BOTTOMLEFT", --relativePoint
								10, --xOffset
								-40, --yOffset
								-500, --Min
								500, --Max
								_G_SLH["SLH_SV"][NC_Profile]["NC"]["xOfs"], --Value
								10, --Step
								"SLH_SV", --SVPath0
								NC_Profile, --SVPath1
								"NC", --SVPath2
								"xOfs", --SVPath3
								"Set X Coordinate?", --text
								"Set X Coordinate\n\nThis is in case the button is moved off screen and you need to recover it.\n\nCoordinates are from center of the screen. Center = 0 , Default = -40\n\nThis setting requires a reload after a change." --tooltip
								)
										
						-- SLH_NC_SLH_NC_yOfs - in seconds
							SLH_NC_SLH_NC_yOfs = securecall(_G_SLH["SLH_SF"]["SLH_CreateSlider"],SLH_NC_Options, --
								"TOPLEFT", --point
								SLH_NC_SLH_NC_xOfs, --relativeFrame
								"SLH_NC_SLH_NC_yOfs" , --FrameName
								"BOTTOMLEFT", --relativePoint
								0, --xOffset
								-50, --yOffset
								-500, --Min
								500, --Max
								_G_SLH["SLH_SV"][NC_Profile]["NC"]["yOfs"], --Value
								10, --Step
								"SLH_SV", --SVPath0
								NC_Profile, --SVPath1
								"NC", --SVPath2
								"yOfs", --SVPath3
								"Set Y Coordinate?", --text
								"Set Y Coordinate\n\nThis is in case the button is moved off screen and you need to recover it.\n\nCoordinates are from center of the screen. Center = 0 , Default = 320\n\nThis setting requires a reload after a change." --tooltip
								)
								
						-- SLH_NC_DisableForCrafting - in seconds								
							SLH_NC_DisableForCrafting = securecall(_G_SLH["SLH_SF"]["SLH_CreateCheckButton"],SLH_NC_Options, --self
								"TOPLEFT", --point
								SLH_NC_SLH_NC_yOfs, --relativeFrame
								"SLH_NC_DisableForCrafting", --FrameName
								"TOPLEFT", --relativePoint
								20, --Width
								20, --Height
								0, --xOffset
								-40, --yOffset
								"SLH_SV", --SVPath0
								NC_Profile, --SVPath1
								"NC", --SVPath2
								"DisableForCrafting", --SVPath3
								"Disable when you Craft the item?", --text
								"Disables when you Craft the item\n\nThis setting requires a reload after a change." --tooltip
								)
								
						-- SLH_NC_SLH_NC_yOfs - in seconds								
							SLH_NC_DisableWhenMailBoxIsOpen = securecall(_G_SLH["SLH_SF"]["SLH_CreateCheckButton"],SLH_NC_Options, --self
								"TOPLEFT", --point
								SLH_NC_DisableForCrafting, --relativeFrame
								"SLH_NC_DisableWhenMailBoxIsOpen", --FrameName
								"TOPLEFT", --relativePoint
								20, --Width
								20, --Height
								0, --xOffset
								-20, --yOffset
								"SLH_SV", --SVPath0
								NC_Profile, --SVPath1
								"NC", --SVPath2
								"DisableWhenMailBoxIsOpen", --SVPath3
								"Disable when Mailbox is open?", --text
								"Disables when Mailbox is open" --tooltip
								)
						
						--Right Side
								
						--SLH_NC_LogOnScan Check Button:
							SLH_NC_LogOnScan = securecall(_G_SLH["SLH_SF"]["SLH_CreateCheckButton"],SLH_NC_Options, --self
								"TOPLEFT", --point
								Enable_SLH_NC_, --relativeFrame
								"SLH_NC_LogOnScan", --FrameName
								"TOPLEFT", --relativePoint
								20, --Width
								20, --Height
								280, --xOffset
								0, --yOffset
								"SLH_SV", --SVPath0
								NC_Profile, --SVPath1
								"NC", --SVPath2
								"LogOnScan", --SVPath3
								"Run Scan on Loading UI?", --text
								"Runs Scan when Loading UI.\n\nSounds useful.  Likely highly annoying for Consumables..." --tooltip
								)
								
										
			end

				
			if _G_SLH["SLH_PCSV"][SLH_PCSV_UnitName]["Config"]["NC_Load"] == "Y" then
				SLH_NC_SetVars(self, event, name, ...)
				SLH_NC_Events(self, event, name, ...)
			end
			if _G_SLH["SLH_PCSV"][SLH_PCSV_UnitName]["Config"]["NC_Hide"] == "N" then
				SLH_NC_Frames(self, event, name, ...)
			end

	end	)	